	list	p=12f675
	#include <p12f675.inc>
	errorlevel -302
	__CONFIG _CP_OFF & _CPD_OFF & _BODEN_OFF & _MCLRE_OFF & _WDT_OFF & _PWRTE_ON & _XT_OSC 

flag	equ	20h	; flag registar
setleds	equ	0	; 0 = do not set leds, 1 = set leds
glbro	equ	21h	; glavni brojac do 250 za 1 sec
hour	equ	22h	; sat                  0...11
min10	equ	23h	; 10 minuta            0...5
min	equ	24h	; minut                0...9
sec10	equ	25h	; 10 sekundi           0...5
sec	equ	26h	; sekund               0...9
debo1	equ	27h	; rotor za debouncing za donji taster
debo2	equ	28h	; rotor za debouncing za gornji taster
byteout	equ	29h	; bajt koji treba siftovati napolje u 4094
count	equ	2ah	; djnz counter
corr1	equ	2bh	; brojac do 6 za korekciju sa 4096 na 4000 KHz


start
	goto	cont
tabela1		;12   1    2    3    4    5    6    7    8    9    10  11
	dt	081h,008h,001h,009h,011h,019h,013h,01bh,017h,01fh,080h,088h
tabela2		;0    1    2    3    4    5    6    7    8    9
	dt	000h,008h,001h,009h,011h,019h,013h,01bh,017h,01fh
	dt	080h,088h,081h,089h,091h,099h,093h,09bh,097h,09fh
	dt	040h,048h,041h,049h,051h,059h,053h,05bh,057h,05fh
	dt	0c0h,0c8h,0c1h,0c9h,0d1h,0d9h,0d3h,0dbh,0d7h,0dfh
	dt	060h,068h,061h,069h,071h,079h,073h,07bh,077h,07fh
	dt	0e0h,0e8h,0e1h,0e9h,0f1h,0f9h,0f3h,0fbh,0f7h,0ffh
	dt	000h,000h,000h,000h				   ; safety
lookup
	movwf	pcl		; jump on w

cont
	movlw	20h
	movwf	fsr
clram
	clrf	indf		; brise interni RAM od 20h do 3fh
	incf	fsr,f
	btfss	fsr,6
	goto	clram
	
	movlw	.6
	movwf	corr1

	clrf	gpio
	movlw	7		; !!!
	movwf	cmcon		; !!!
	bsf	status,rp0	; !!!
	clrf	ansel		; !!!
	movlw	b'00111000'	; gpio 0,1,2 outputs
	movwf	trisio
	movlw	83h		; prescaler 1:16 to timer0, no pullups
	movwf	option_reg
	bcf     status,rp0	; !!! reselect file register bank 0
	goto	farm2
farm
	btfss	flag,setleds
	goto	noshow
farm2				; pokazi vreme (set leds) --------------------
	bcf	flag,setleds
	movf	hour,w
	andlw	0fh		; safety
	addlw	tabela1
	call	shifthour	; set hour leds
	movlw	min10
	movwf	fsr
	call	shiftout	; set min leds
	call	shiftout	; set sec leds

	bsf	gpio,1		; rclk /  write serial to paralel registers
	nop
	nop
	clrf	gpio		; rclk \

noshow				; --------------------------------------------
	btfss	intcon,t0if
	goto	noshow
				; 4,096 ms (244,140625 Hz) tick here
	bcf	intcon,t0if
				; test keys
	movlw	04h
	movwf	gpio		; sclk /  (gpio,2) for lower key test only
	nop
	bcf	status,c
	btfsc	gpio,3		; key input
	bsf	status,c	; c set ako je taster pritisnut
	rlf	debo1,f		; donji taster (minuti)
	clrf	gpio		; sclk \

	movf	debo1,w
	addlw	0ffh
	bnz	nojustmin
				; upravo pritisnut donji taster (minuti)
	movlw	.244
	movwf	glbro
	clrf	sec
	clrf	sec10

	incf	min,f
	movlw	-.10
	addwf	min,w
	bnc	nomin0

	clrf	min
	incf	min10,f
	movlw	-.6
	addwf	min10,w
	bnc	nomin0
	clrf	min10
nomin0
	bsf	flag,setleds
	goto	nokeys
nojustmin
	bsf	gpio,0		; gpio,0 /   for upper key test only
	nop
	bcf	status,c
	btfsc	gpio,3		; key input
	bsf	status,c	; c set ako je taster pritisnut
	rlf	debo2,f		; gornji taster (sati)
	clrf	gpio		; gpio,0 \
	movf	debo2,w
	addlw	0ffh
	bnz	nokeys
				; upravo pritisnut gornji taster (sati)
	incf	hour,f
	movlw	-.12
	addwf	hour,w
	bnc	noh0
	clrf	hour
noh0
	bsf	flag,setleds
nokeys				; ------------------------------------------
	decf	glbro,f
	bnz	farm		; not 1 sec yet
				; 1 sec tick here
	movlw	.244
	movwf	glbro

	decf	corr1,f
	bnz	nyet6
	movlw	.6
	movwf	corr1
	incf	glbro
nyet6
				; inc sec
	incf	sec,f
	movlw	-.10
	addwf	sec,w
	bnc	farm2
				; inc sec10
	clrf	sec
	incf	sec10,f
	movlw	-.6
	addwf	sec10,w
	bnc	farm2
				; inc min
	clrf	sec10
	incf	min,f
	movlw	-.10
	addwf	min,w
	bnc	farm2
				; inc min10
	clrf	min
	incf	min10,f
	movlw	-.6
	addwf	min10,w
	bnc	farm2
				; inc hour
	clrf	min10
	incf	hour,f
	movlw	-.12
	addwf	hour,w
	bnc	farm2
				; midnight
	clrf	hour
	goto	farm2
				; -----------------------------------------

shiftout
	bcf	status,c
	rlf	indf,w		; w = desetice * 2
	movwf	byteout		; byteout = desetice * 2
	rlf	byteout,f	; byteout = desetice * 4
	rlf	byteout,f	; byteout = desetice * 8
	addwf	byteout,w	; w = desetice * 10
	incf	fsr,f		; ptr +
	addwf	indf,w		; w = desetice * 10 + jedinice
	andlw	3fh		; safety
	addlw	tabela2
	incf	fsr,f		; ptr +
shifthour
	call	lookup
	movwf	byteout		; this byte will be shifted out to 4094

	movlw	.8
	movwf	count
x8
	clrf	gpio
	rlf	byteout,f
	btfsc	status,c
	bsf	gpio,0		; set serial data bit on gpio,0
	nop
	nop
	bsf	gpio,2		; sclk /
	nop
	nop
	bcf	gpio,2		; sclk \
	decfsz	count,f
	goto	x8
	return

	end
